class Connection {
  final ConnectionStatus status;

  final String name;

  final String id;

  final Uri profileUrl;

  final String network;

  final Uri avatarUrl;

  Connection(
      {this.status = ConnectionStatus.none,
      this.name = '',
      this.id = '',
      Uri? profileUrl,
      this.network = '',
      Uri? avatarUrl})
      : profileUrl = profileUrl ?? Uri(),
        avatarUrl = avatarUrl ?? Uri();

  Connection copy(
          {ConnectionStatus? status,
          String? name,
          String? id,
          Uri? profileUrl,
          String? network,
          Uri? avatarUrl}) =>
      Connection(
        status: status ?? this.status,
        name: name ?? this.name,
        id: id ?? this.id,
        profileUrl: profileUrl ?? this.profileUrl,
        network: network ?? this.network,
        avatarUrl: avatarUrl ?? this.avatarUrl,
      );

  @override
  String toString() {
    return 'Connection{status: $status, name: $name, id: $id, profileUrl: $profileUrl, network: $network, avatar: $avatarUrl}';
  }
}

enum ConnectionStatus {
  youFollowThem,
  theyFollowYou,
  mutual,
  you,
  none,
}

extension FriendStatusWriter on ConnectionStatus {
  String name() {
    switch (this) {
      case ConnectionStatus.youFollowThem:
        return "You Follow Them";
      case ConnectionStatus.theyFollowYou:
        return "They Follow You";
      case ConnectionStatus.mutual:
        return "Follow each other";
      case ConnectionStatus.none:
        return "Not connected";
      case ConnectionStatus.you:
        return "You";
    }
  }
}
